setlocal
if "%ntver_queried%" == "1" exit /b 0

rem Architecture
if exist "%PROGRAMFILES(X86)%" (set ntver_arch=64) else (set ntver_arch=32)

rem Version
for /f "tokens=2*" %%a in ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "CurrentBuild" 2^>^&1^|find "REG_"') do set "ntver_build=%%b"
if "%ntver_build%" == "" (
	echo * Warning: CurrentBuild not found, assuming Windows 2000.
	set ntver_build=2195
)
rem 2000
set "ntver_major=5"
rem XP
if %ntver_build% geq 2600 set "ntver_minor=1"
rem XP x64
if %ntver_build% geq 3790 set "ntver_minor=2"
rem Vista
if %ntver_build% geq 6002 set "ntver_major=6" & set "ntver_minor=0"
rem 7
if %ntver_build% geq 7601 set "ntver_minor=1"
rem 8
if %ntver_build% geq 9200 set "ntver_minor=2"
rem 8.1
if %ntver_build% geq 9600 set "ntver_minor=3"
rem 10
if %ntver_build% geq 10240 set "ntver_major=10" & set "ntver_minor=0"
if %ntver_build% geq 10586 set "ntver_minor=1"
if %ntver_build% geq 14393 set "ntver_minor=2"
if %ntver_build% geq 15063 set "ntver_minor=3"
if %ntver_build% geq 16299 set "ntver_minor=4"
if %ntver_build% geq 17134 set "ntver_minor=5"
if %ntver_build% geq 17763 set "ntver_minor=6"
if %ntver_build% geq 18362 set "ntver_minor=7"
if %ntver_build% geq 18363 set "ntver_minor=8"
if %ntver_build% geq 19041 set "ntver_minor=9"
if %ntver_build% geq 19042 set "ntver_minor=10"
if %ntver_build% geq 19043 set "ntver_minor=11"
if %ntver_build% geq 19044 set "ntver_minor=12"
if %ntver_build% geq 19045 set "ntver_minor=13"
rem 11
if %ntver_build% geq 22000 set "ntver_minor=14"
if %ntver_build% geq 22621 set "ntver_minor=15"
if %ntver_build% geq 22631 set "ntver_minor=16"

rem Service Pack
for /f "tokens=4*" %%a in ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "CSDVersion" 2^>^&1^|find "REG_"') do set "ntver_sp=%%b"
if "%ntver_sp%" == "" set ntver_sp=0

rem Easy to remember version numbers
set "ntver_num="
if %ntver_major% lss 10 (
	set "ntver_num=%ntver_num%0%ntver_major%"
) else (
	set "ntver_num=%ntver_num%%ntver_major%"
)
if %ntver_minor% lss 10 (
	set "ntver_num=%ntver_num%0%ntver_minor%"
) else (
	set "ntver_num=%ntver_num%%ntver_minor%"
)
if %ntver_sp% lss 10 (
	set "ntver_num=%ntver_num%0%ntver_sp%"
) else (
	set "ntver_num=%ntver_num%%ntver_sp%"
)
set "ntver_pretty=%ntver_major%.%ntver_minor%.%ntver_sp%"

if %ntver_build% gtr 22631 echo * Warning: Unsupported OS (Assuming NT %ntver_pretty%)
echo * Windows NT %ntver_pretty% (%ntver_arch%-bit)
echo Major: %ntver_major%
echo Minor: %ntver_minor%
echo Service Pack: %ntver_sp%
echo Build: %ntver_build%
echo winver: %ntver_num%
echo.

endlocal & set "ntver_arch=%ntver_arch%" & set "ntver_major=%ntver_major%" & set "ntver_minor=%ntver_minor%" & set "ntver_sp=%ntver_sp%" & set "ntver_build=%ntver_build%" & set "ntver_num=%ntver_num%" & set "ntver_queried=1"