@echo off
setlocal enabledelayedexpansion
cd /d "%~dp0"

if "%~1" == "" goto nofile

set "section="
for /F "usebackq tokens=*" %%s in ("%~1") do (
	set "line=%%s"
	call :stripLineStart "!line!" line
	call :stripLineComment "!line!" line
	call :stripLineEnd "!line!" line
	call :getLineType "!line!" lineType
	
	if "!lineType!" == "1" (
		call :getLineSection "!line!" section
		call :stripLineStart "!section!" section
		call :stripLineEnd "!section!" section
		set handler=0
		if "!section!" == "Control Panel\Cursors" set handler=1
		if "!section!" == "Control Panel\Colors" set handler=1
		if "!section!" == "Control Panel\Desktop" set handler=2
	)
	
	if "!lineType!" == "2" (
		if "!handler!" == "1" (
			call :getLineValue "!line!" key value
			call :stripLineStart "!key!" key
			call :stripLineEnd "!key!" key
			call :stripLineStart "!value!" value
			call :stripLineEnd "!value!" value
			
			echo !section!\!key! = "!value!"
			reg add "HKCU\!section!" /v "!key!" /t REG_SZ /d "!value!" /f >nul
		)
		
		if "!handler!" == "2" (
			call :getLineValue "!line!" key value
			call :stripLineStart "!key!" key
			call :stripLineEnd "!key!" key
			
			if "!key!" == "Wallpaper" (
				call :stripLineStart "!value!" value
				call :stripLineEnd "!value!" value
				echo !section!\!key! = "!value!"
				reg add "HKCU\!section!" /v "!key!" /t REG_SZ /d "!value!" /f >nul
			)
		)
	)
)
exit /b 0

:getLineType
setlocal enabledelayedexpansion
set "line=%~1"
set "output=0"
if "%line%" == "" goto getLineTypeOutput
if "%line:~0,1%" == "[" (
	set "output=1"
	goto :getLineTypeOutput
)

for /F "tokens=1,2 delims==" %%a in ("%line%") do (
	if not "%%a" == "%line%" (
		set "output=2"
		goto :getLineTypeOutput
	)
)

:getLineTypeOutput
endlocal & set "%~2=%output%" & exit /b 0

:getLineSection
setlocal enabledelayedexpansion
set "line=%~1"
set "output="
if "%line%" == "" goto getLineSectionOutput
for /F "tokens=1,2 delims=[]" %%a in ("%line%") do (
	set "output=%%a"
)
:getLineSectionOutput
endlocal & set "%~2=%output%" & exit /b 0

:getLineValue
setlocal
set "line=%~1"
set "output1="
set "output2="
for /F "tokens=1,2 delims==" %%a in ("%line%") do (
	set "output1=%%a"
	set "output2=%%b"
)
rem call :stripLineStart "%output1%" output1
rem call :stripLineEnd "%output1%" output1
rem call :stripLineStart "%output2%" output2
rem call :stripLineEnd "%output2%" output2
endlocal & set "%~2=%output1%" & set "%~3=%output2%" & exit /b 0

:getStringLength
setlocal enabledelayedexpansion
set "line=%~1"
set "index=0"
if "%line%" == "" goto getStringLengthOutput
:getStringLengthLoop
if "!line:~%index%,1!" == "" goto getStringLengthOutput
set /a "index=%index%+1"
goto getStringLengthLoop
:getStringLengthOutput
endlocal & set "%~2=%index%" & exit /b 0

:stripLineStart
setlocal enabledelayedexpansion
set "line=%~1"
set "output="
for /f "tokens=* delims=	 " %%s in ("%line%") do (
	set "output=%%s"
)
endlocal & set "%~2=%output%" & exit /b 0

:stripLineEnd
setlocal enabledelayedexpansion
set "line=%~1"
set "output="
for /f "tokens=* delims=	 " %%s in ("%line%") do (
	set "output=%%s"
)
endlocal & set "%~2=%output%" & exit /b 0

:stripLineComment
setlocal
set "output="
set "line=%~1"
if "%line%" == "" goto stripLineCommentOutput
for /F "tokens=1 delims=;#" %%s in ("%line%") do (
	set "output=%%s"
)
:stripLineCommentOutput
endlocal & set "%~2=%output%" & exit /b 0

:nofile
echo Drag a .theme file into this batch file to apply it.
pause
exit /b 1